
//CirkelVorm is een class waarin de vormen rect en ellipse in een cirkel worden gerangschikt 
//een extra methode en constructor tbv een niet roterende rechthoek toegevoegd 
class CirkelVorm {  
  float x;
  float y;
  float b;
  float l;
  float diameter;
  float hoek;
  float snelh;
  float xpos;
  int rotatiemode;
  int aantal;
  float teller;
  color c;

  //Argumenten van de constructor:  
  //vormlengte, vormbreedte, cirkeldiameter, start draaihoek, draaisnelheid, xpos is positie cirkel op de x as 
  //rotatiemode, aantal vormen, kleur. 

  CirkelVorm(float l_, float b_, float d_, float hoek_, float snelh_, float xpos_, int rmod_, int aantal_, color c_) {  
    b = b_;  
    l = l_;  
    diameter = d_; 
    hoek = hoek_;
    xpos = xpos_;
    snelh = snelh_; 
    rotatiemode = rmod_; 
    aantal = aantal_; 
    c = c_;
  } 
  //Constructor voor de niet roterende rechthoek 
  CirkelVorm(float x_, float y_, float l_, float b_, color c_) { 
    x = x_; 
    y = y_; 
    l = l_; 
    b = b_; 
    c = c_;
  }

  void rechthoek() {
    teller = teller + snelh; 
    for (int i = 0; i < 360; i+=360/aantal) { 
      float x = xpos + sin(radians(i))* diameter; 
      float y = height/2 + cos(radians(i))* diameter; 
      pushMatrix(); 
      translate(x, y); 
      if (rotatiemode == 1) rotate(radians(-i+teller+hoek));
      if (rotatiemode == 2) rotateX(radians(-i+teller+hoek)); 
      if (rotatiemode == 3) rotateY(radians(-i+teller+hoek));
      if (rotatiemode == 4) {
        rotateX(radians(hoek));
        rotateZ(radians(-i+teller+hoek));
      }
      fill(c); 
      rectMode(CENTER); 
      rect(0, 0, l, b, 25); 
      popMatrix();
    }
  }

  void ellips() {
    teller = teller + snelh; 
    for (int i = 0; i < 360; i+=360/aantal) { 
      float x = xpos + sin(radians(i))* diameter; 
      float y = height/2 + cos(radians(i))* diameter; 
      pushMatrix(); 
      translate(x, y); 
      if (rotatiemode == 1) rotate(radians(-i+teller+hoek)); 
      if (rotatiemode == 2) rotateX(radians(-i+teller+hoek)); 
      if (rotatiemode == 3) rotateY(radians(-i+teller+hoek)); 
      if (rotatiemode == 4) {
        rotateX(radians(hoek));
        rotateZ(radians(-i+teller+hoek));
      }
      fill(c); 
      ellipse(0, 0, l, b); 
      popMatrix();
    }
  }

  void rechthoekNietRoterend() { 
    rectMode(CENTER); 
    fill(c); 
    rect(x, y, l, b);
  }
}